package com.tutorialesprogramacionya.proyecto032

import android.media.MediaPlayer
import android.media.MediaRecorder
import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.os.Environment
import kotlinx.android.synthetic.main.activity_main.*
import java.io.File
import java.io.IOException

class MainActivity : AppCompatActivity(), MediaPlayer.OnCompletionListener {
    lateinit var recorder: MediaRecorder
    lateinit var player: MediaPlayer
    lateinit var archivo: File

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        boton1.setOnClickListener {
            recorder = MediaRecorder()
            recorder.setAudioSource(MediaRecorder.AudioSource.MIC)
            recorder.setOutputFormat(MediaRecorder.OutputFormat.THREE_GPP)
            recorder.setAudioEncoder(MediaRecorder.AudioEncoder.AMR_NB)
            val path = File(Environment.getExternalStorageDirectory()
                    .getPath())
            try {
                archivo = File.createTempFile("temporal", ".3gp", path)
            } catch (e: IOException) {
            }

            recorder.setOutputFile(archivo.absolutePath)
            try {
                recorder.prepare()
            } catch (e: IOException) {
            }

            recorder.start()
            tv1.text ="Grabando"
            boton1.setEnabled(false)
            boton2.setEnabled(true)
        }

        boton2.setOnClickListener {
            recorder.stop()
            recorder.release()
            player = MediaPlayer()
            player.setOnCompletionListener(this)
            try {
                player.setDataSource(archivo.absolutePath)
            } catch (e: IOException) {
            }

            try {
                player.prepare()
            } catch (e: IOException) {
            }

            boton1.setEnabled(true)
            boton2.setEnabled(false)
            boton3.setEnabled(true)
            tv1.text = "Listo para reproducir"
        }

        boton3.setOnClickListener {
            player.start();
            boton1.setEnabled(false);
            boton2.setEnabled(false);
            boton3.setEnabled(false);
            tv1.setText("Reproduciendo");
        }
    }

    override fun onCompletion(mp: MediaPlayer) {
        boton1.setEnabled(true)
        boton2.setEnabled(true)
        boton3.setEnabled(true)
        tv1.setText("Listo")
    }
}
